##
## References:
##   • https://goteleport.com/docs/admin-guides/infrastructure-as-code/terraform-provider/
##   • https://goteleport.com/docs/admin-guides/access-controls/guides/impersonation/
##

{{- if .Values.terraform.enabled }}
{{- $terraformRoleName := printf "%s-cluster-manager" .Values.terraform.name -}}
---
# Schema: https://goteleport.com/docs/reference/operator-resources/resources-teleport-dev-rolesv7/
apiVersion: resources.teleport.dev/v1
kind: TeleportRoleV7
metadata:
  name: {{ $terraformRoleName }}
  labels:
    {{- include "common.labels.standard" $ | nindent 4 }}
spec:
  options:
    max_session_ttl: 8760h # 1 year
  allow:
    db_labels:
      '*': '*'
    app_labels:
      '*': '*'
    node_labels:
      '*': '*'
    rules:
      - resources:
          - access_list
          - app
          - bot
          - cluster_auth_preference
          - cluster_networking_config
          - db
          - device
          - github
          - login_rule
          - node
          - oidc
          - okta_import_rule
          - role
          - saml
          - session_recording_config
          - token
          - trusted_cluster
          - user
        verbs: ['list', 'create', 'read', 'update', 'delete']
---
# TODO: Remove the impersonator role once switched to Machine ID.
# Schema: https://goteleport.com/docs/reference/operator-resources/resources-teleport-dev-rolesv7/
apiVersion: resources.teleport.dev/v1
kind: TeleportRoleV7
metadata:
  name: {{ .Values.terraform.name }}-impersonator
  labels:
    {{- include "common.labels.standard" $ | nindent 4 }}
spec:
  options:
    max_session_ttl: 1h # The maximum TTL of certificates issued to the users with this role
  allow:
    impersonate:
      users: ['{{ .Values.terraform.name }}']
      roles: ['{{ $terraformRoleName }}']
---
# TODO: This has to be switched to a Bot once a CRD for TeleportBot resource is available.
# Schema: https://goteleport.com/docs/reference/operator-resources/resources-teleport-dev-users/
apiVersion: resources.teleport.dev/v2
kind: TeleportUser
metadata:
  name: {{ .Values.terraform.name }}
  labels:
    {{- include "common.labels.standard" $ | nindent 4 }}
spec:
  roles:
    - {{ $terraformRoleName }}
{{- end }}
